from djangoprime.core.base import BaseEnum


class EmailExceptionEnum(BaseEnum):
    EMAIL_SENDING_FAILED = 'Email sending failed. Please try again later.'
    INVALID_EMAIL_FORMAT = 'Invalid email format provided.'
    RECIPIENT_NOT_FOUND = 'The specified email recipient does not exist.'
    EMAIL_BLOCKED = 'The email was blocked or bounced.'
    TOO_MANY_RECIPIENTS = 'Too many recipients specified for this email.'
    MISSING_CONTENT = 'Email content is missing. Please provide a valid message.'
    ATTACHMENT_TOO_LARGE = 'One or more attachments exceed the allowed size limit.'
    UNSUPPORTED_ATTACHMENT_TYPE = 'One or more attachments are of unsupported file types.'
    EMAIL_SERVICE_UNAVAILABLE = 'The email service is currently unavailable. Please try again later.'
    EMAIL_NOT_VERIFIED = 'The email address has not been verified. Please verify before sending.'
    EMAIL_LIMIT_REACHED = 'Daily email sending limit has been reached.'
    INVALID_TEMPLATE = 'The specified email template is invalid or does not exist.'
    SENDING_DELAYED = 'Email sending is temporarily delayed. Please try again shortly.'
    DISPOSABLE_EMAIL_NOT_ALLOWED = 'Disposable email addresses are not allowed. Please use a valid email.'
    DISPOSABLE_EMAIL_DETECTED = 'A disposable email address has been detected. Please use a permanent email.'
    IS_DISPOSABLE_EMAIL = 'This email address is identified as a disposable email. Please provide a valid address.'
    DISPOSABLE_EMAIL_SERVICE_BLOCKED = 'Emails from disposable email services are blocked.'
    TEMPORARY_EMAIL_NOT_ALLOWED = 'Temporary email addresses are not permitted. Please provide a valid email.'
    REUSABLE_EMAIL_REQUIRED = 'A reusable email address is required for this operation.'
    MULTIPLE_DISPOSABLE_EMAILS_NOT_ALLOWED = 'Multiple disposable email addresses are not permitted in a single request.'
    EMAIL_ALREADY_SENT = 'An email has already been sent to this address for the current operation.'
    INVALID_EMAIL_CREDENTIALS = 'The email credentials provided are invalid. Please check and try again.'
    EMAIL_BLOCKED_BY_PROVIDER = 'The email has been blocked by the email service provider.'
    EMAIL_DOMAIN_NOT_ALLOWED = 'The email domain is not allowed. Please use a different email address.'
    UNSUBSCRIBE_FAILED = 'Failed to unsubscribe from the mailing list. Please try again later.'
    EMAIL_CONFIRMATION_FAILED = 'Email confirmation failed. Please check your confirmation link and try again.'
    EMAIL_VERIFICATION_FAILED = 'Email verification failed. Please request a new verification email.'
    EMAIL_BLACKLISTED = 'This email address is blacklisted due to previous violations.'
    EMAIL_TEMPORARILY_UNAVAILABLE = 'The email service is temporarily unavailable. Please try again later.'
    INVALID_RECIPIENT_ADDRESS = 'The recipient address is invalid or malformed.'
    EMAIL_ACCOUNT_NOT_FOUND = 'No email account associated with this address could be found.'
    EMAIL_CONTENT_TOO_LONG = 'The email content exceeds the allowed character limit.'
    EMAIL_SUBJECT_MISSING = 'The email subject is missing. Please provide a valid subject.'
    ATTACHMENT_NOT_FOUND = 'One or more specified attachments could not be found.'
    SMTP_CONNECTION_ERROR = "Failed to establish a connection to the SMTP server."
